VERSION 5.00
Begin VB.Form MainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Image Transfer Receive"
   ClientHeight    =   8025
   ClientLeft      =   150
   ClientTop       =   840
   ClientWidth     =   10560
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   535
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   704
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer CheckMessagesTimer 
      Interval        =   100
      Left            =   9960
      Top             =   120
   End
   Begin VB.ComboBox uxSerialPortList 
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   150
      Width           =   1215
   End
   Begin VB.CommandButton uxDisconnectButton 
      Caption         =   "Disconnect"
      Height          =   375
      Left            =   2760
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton uxConnectButton 
      Caption         =   "Connect"
      Height          =   375
      Left            =   1440
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.Image Image1 
      Height          =   6975
      Left            =   1080
      Stretch         =   -1  'True
      Top             =   600
      Width           =   8415
   End
   Begin VB.Label uxStatusBar 
      Height          =   300
      Left            =   120
      TabIndex        =   3
      Top             =   7680
      Width           =   10455
   End
   Begin VB.Menu uxFileMenuItem 
      Caption         =   "&File"
      Begin VB.Menu uxFileExitMenuItem 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Public MM As MultiModem




'************************************************
'* Private Sub Form_Load()
'* Summary:     Occurs on form load, readies the form for use
'************************************************
Private Sub Form_Load()

    Dim i As Integer

    'Populate serial port list
    For i = 1 To 16

        uxSerialPortList.AddItem "COM" & i

    Next i
    
    'Select COM1 as default
    uxSerialPortList.Text = "COM1"

    'Enable only the Connect Button
    SetButtons (False)
    
    'Set MM to new instance of MultiModem object
    Set MM = New MultiModem
    

End Sub



'************************************************
'* Private Sub Form_Unload(Cancel As Integer)
'* Summary:     Occurs on form unload, disposes of multimodem object
'************************************************
Private Sub Form_Unload(Cancel As Integer)

    'Dispose of MultiModem object
    Set MM = Nothing

End Sub



'************************************************
'* Private Sub uxFileExitMenuItem_Click()
'* Summary:     Handles File->Exit menu item which closes program
'************************************************
Private Sub uxFileExitMenuItem_Click()

    'Disconnect from serial port if connected
    If uxDisconnectButton.Enabled Then uxDisconnectButton_Click

    'Unload the form
    Unload Me

End Sub




'************************************************
'* Private Sub uxConnectButton_Click()
'* Summary:     Handles Connect Button, connects to serial port
'************************************************
Private Sub uxConnectButton_Click()

    Dim port As Integer
    
    port = CInt(Mid(uxSerialPortList.Text, 4))

    'Try connecting to selected port, display message if error connecting
    If Not MM.Connect(port) Then
        MsgBox "Error connecting to port " & port, vbExclamation, "MultiModem Demo Application"
        Exit Sub
    End If
    
    'Disable connect button and enable other buttons
    SetButtons (True)
    
    'Display message
    uxStatusBar.Caption = "Connected to port " & port
    
    Dim response As String
    MM.SendATCommand "ATE0", response, 0

End Sub



'************************************************
'* Private Sub uxDisconnectButton_Click()
'* Summary:     Handles Disconnect Button, disconnects from serial port
'************************************************
Private Sub uxDisconnectButton_Click()

    Dim port As Integer
    
    port = CInt(Mid(uxSerialPortList.Text, 4))
    
    'Try disconnecting, display message if error disconnecting
    If Not MM.Disconnect Then
        MsgBox "Error disconnecting from port " & port, vbExclamation, "MultiModem Demo Application"
        Exit Sub
    End If
    
    'Enable connect button and disable other buttons
    SetButtons (False)
    
    'Display message
    uxStatusBar.Caption = "Disconnected from port " & port


End Sub



Private Sub CheckMessagesTimer_Timer()

    Dim index As Integer, unread As Boolean, number As String, timestamp As String, msg As String

    If MM.CheckMessages(index) Then
    
        MM.SetCharacterSet "HEX"
        MM.ReadMessage index, unread, number, timestamp, msg
        
        MsgBox "Message Recieved"
        
        SaveMsg (msg)
    
    End If

End Sub



'************************************************
'* Private Function FormatPhoneNumber(number As String)
'* Summary:     Formats a 10 or 11 digit phone number
'* Parameters:  number - phone number to format
'************************************************
Private Function FormatPhoneNumber(number As String)

    If Len(number) = 10 Then
        FormatPhoneNumber = Mid(number, 1, 3) & "-" & _
                            Mid(number, 4, 3) & "-" & _
                            Mid(number, 7, 4)
    ElseIf Len(number) = 11 Then
        FormatPhoneNumber = Mid(number, 1, 1) & "-" & _
                            Mid(number, 2, 3) & "-" & _
                            Mid(number, 5, 3) & "-" & _
                            Mid(number, 8, 4)
    Else
        FormatPhoneNumber = number
    End If

End Function


'************************************************
'* Private Sub SetButtons(enable As Boolean)
'* Summary:     Grays out buttons when we are not
'*              connected to the serial port
'* Parameters:  enable - True to enable all buttons
'*              False to disable all except for Connect Button
'************************************************
Private Sub SetButtons(enable As Boolean)

    If enable Then
    
        'Disable Connect Button and Serial Port List, enable the rest
        uxConnectButton.Enabled = False
        uxSerialPortList.Enabled = False
        uxDisconnectButton.Enabled = True
        
    Else
    
        'Enable Connect Button and Serial Port List, disable the rest
        uxConnectButton.Enabled = True
        uxSerialPortList.Enabled = True
        uxDisconnectButton.Enabled = False
        
    End If

End Sub


Private Sub SaveMsg(msg As String)

    Dim f As Integer
    Dim c As String * 1
    Dim t As String
    Dim i As Integer
    
    f = FreeFile

    Open "pic.bmp" For Binary As #f
    
    For i = 1 To Len(msg) Step 2
    
        c = Chr(CInt("&H" & Mid(msg, i, 2)))
        Put #f, , c

    Next i
    
    Close #f
    
    Image1.Picture = LoadPicture("pic.bmp")

End Sub
